#pragma once

#include "GLM/gtx.hpp"
#include "GLM/gtc.hpp"

/** Texture coordinates for the quad. */
static const glm::vec2 quadTexCoord[4] =
{
    glm::vec2( 0, 0),
    glm::vec2( 1, 0),
    glm::vec2( 1, 1),
    glm::vec2( 0, 1),
};

/** Indices for the vertices for the quad. */
static const int quadIndices[6] = 
{
	0, 1, 2, 0, 2, 3
};

/** Texture coordinates for the cube. */
static const glm::vec3 cubeTexCoord[24] =
{
	//back
    glm::vec3(0, 0, 1),
    glm::vec3(1, 0, 1),
    glm::vec3(1, 1, 1),
    glm::vec3(0, 1, 1),

	//bottom
    glm::vec3(0, 0, 1),
    glm::vec3(1, 0, 1),
    glm::vec3(1, 0, 0),
    glm::vec3(0, 0, 0),

	//right
    glm::vec3(1, 0, 1),
    glm::vec3(1, 1, 1),
    glm::vec3(1, 1, 0),
    glm::vec3(1, 0, 0),

	//top
    glm::vec3(1, 1, 1),
    glm::vec3(0, 1, 1),
    glm::vec3(0, 1, 0),
    glm::vec3(1, 1, 0),

	//left
    glm::vec3(0, 1, 1),
    glm::vec3(0, 0, 1),
    glm::vec3(0, 0, 0),
    glm::vec3(0, 1, 0),

	//front
    glm::vec3(0, 0, 0),
    glm::vec3(1, 0, 0),
    glm::vec3(1, 1, 0),
    glm::vec3(0, 1, 0)
};

/** Indices for the vertices for the cube. */
static const int cubeIndices[36] =
{
    0, 2, 1, 0, 3, 2,
    4, 5, 6, 4, 6, 7,
    8, 9, 10, 8, 10, 11,
    12, 13, 14, 12, 14, 15,
    16, 17, 18, 16, 18, 19,
    20, 21, 22, 20, 22, 23,
};