#include "Cuda.h"


Cuda::Cuda(void)
{
	m_plane = Primitives::GetPlane();
}


Cuda::~Cuda(void)
{
}

void Cuda::ArrayCopy(void* srcArray, cudaArray* dstArray, size_t size, cudaExtent res ) 
{
	cudaMemcpy3DParms copyparticle_parameter = {0};

	copyparticle_parameter.srcPtr.ptr   = srcArray;
	copyparticle_parameter.srcPtr.pitch = res.width*size;
	copyparticle_parameter.srcPtr.xsize = res.width;
	copyparticle_parameter.srcPtr.ysize = res.height;

	copyparticle_parameter.dstArray = dstArray ;
	copyparticle_parameter.extent   = res;
	copyparticle_parameter.kind     = cudaMemcpyDeviceToDevice;

	cutilSafeCall(cudaMemcpy3D(&copyparticle_parameter));
}

void Cuda::ArrayCopy(cudaArray* srcArray, cudaArray* dstArray, size_t size, cudaExtent res ) 
{	
	cudaMemcpy3DParms copyparticle_parameter = {0};

	copyparticle_parameter.srcArray   = srcArray;
	copyparticle_parameter.dstArray = dstArray;
    copyparticle_parameter.extent   = res;
	copyparticle_parameter.kind     = cudaMemcpyDeviceToDevice;

	cutilSafeCall(cudaMemcpy3D(&copyparticle_parameter));
}

void Cuda::ArrayCopy(void* srcArray, void* dstArray, size_t size, cudaExtent res ) 
{
	cudaMemcpy3DParms copyparticle_parameter = {0};

	copyparticle_parameter.srcPtr.ptr   = srcArray;
	copyparticle_parameter.srcPtr.pitch = res.width*size;
	copyparticle_parameter.srcPtr.xsize = res.width;
	copyparticle_parameter.srcPtr.ysize = res.height;

	copyparticle_parameter.dstPtr.ptr   = dstArray;
	copyparticle_parameter.dstPtr.pitch = res.width*size;
	copyparticle_parameter.dstPtr.xsize = res.width;
	copyparticle_parameter.dstPtr.ysize = res.height;

	copyparticle_parameter.extent   = res;
	copyparticle_parameter.kind     = cudaMemcpyDeviceToDevice;

	cutilSafeCall(cudaMemcpy3D(&copyparticle_parameter));
}


void Cuda::ArrayCopy(cudaArray* srcArray, void* dstArray, size_t size, cudaExtent res ) 
{
	cudaMemcpy3DParms copyparticle_parameter = {0};
	copyparticle_parameter.srcArray   = srcArray;
 
	copyparticle_parameter.dstPtr.ptr   = dstArray;
	copyparticle_parameter.dstPtr.pitch = res.width*size;
	copyparticle_parameter.dstPtr.xsize = res.width;
    copyparticle_parameter.dstPtr.ysize = res.height;

	copyparticle_parameter.extent   = res;
	copyparticle_parameter.kind     = cudaMemcpyDeviceToDevice;

	cutilSafeCall(cudaMemcpy3D(&copyparticle_parameter));
}	