#pragma once
#include "common.hpp"
#include "Camera.h"
#include "VertexGeometry.h"
#include "Primitives.h"

// Utilities and System includes
#include <shrUtils.h>
#include <cutil_inline.h>
#include <cutil_gl_inline.h>
#include <channel_descriptor.h>

#include <vector_types.h>
#include <vector_functions.h>
#include <driver_functions.h>
#include <cuda_gl_interop.h>

#include <glm/glm.hpp>
#include <glm/gtx/transform.hpp> 
//#include <glm/gtc/type_ptr.hpp> 
#include <glm\gtc\matrix_projection.hpp>
#include <glm/gtc/matrix_transform.hpp>

class Cuda
{
public:
	/**
	 * Standardconstructor
	 **/
	Cuda(void);
	/**
	 * Standarddeconstructor
	 **/
	~Cuda(void);

	/**
	 * Copy Array 
	 */
	void ArrayCopy(cudaArray* srcArray, void* dstArray, size_t size, cudaExtent res );
	/**
	 * Copy Array 
	 */
	void ArrayCopy(void* srcArray, void* dstArray, size_t size, cudaExtent res );
	
	/**
	 * Copy Array 
	 */
	void ArrayCopy(cudaArray* srcArray, cudaArray* dstArray, size_t size, cudaExtent res );
	/**
	 * Copy Array 
	 */
	void ArrayCopy(void* srcArray, cudaArray* dstArray, size_t size, cudaExtent res );


	glm::mat4 m_camView;
	glm::mat4 m_camProj;

	VertexGeometry* m_plane;
};

