#pragma once
#include "Geometry.h"
#include <vector>

class INode
{
public:
	/** 
	 * Standardconstructor
	 **/
	INode();
	/** 
	 * Constructor
	 * @param geo Geometry object
	 **/
	INode(Geometry* geo);
	//virtual ~INode ()=0;
	/** 
	 * Not used
	 **/
	int GetUsed () const;
	/** 
	 * THis method attach a node to the node
	 * @param node node to attack
	 **/
	int AttachChild (INode* pkChild);
	/** 
	 * THis method detach a node to the node
	 * @param node node to detach
	 **/
	int DetachChild (INode* pkChild);
	/** 
	 * THis method detach a node to the node
	 * @param node index of node to detach
	 * @return Node which was detached
	 **/
	INode* DetachChildAt (int i);
	/** 
	 * This method sets another child at the specified index
	 * @param index index of node to detach
	 * @param node index of new node
	 * @return Node which was detached
	 **/
	INode* SetChild (int i, INode* pkChild);
	/**
	 * This method returns the child object
	 * @attach selected node
	 */
	INode* GetChild (int i);

	/**
	 * This method returns the attached geometry object
	 * @return attached object
	 */
	Geometry* GetGeometry();
	/**
	 * This method attaches a geometry object
	 * @param geo  object to attach
	 */
	void SetGeometry(Geometry* geo);

protected:
	std::vector<INode*> m_kChild;  //Sollte automatisch wachsen

	Geometry* m_kGeometry;

protected:
	//virtual void UpdateWorldData (double dAppTime);
	//virtual void UpdateWorldBound ();

//	virtual void UpdateState (std::vector<GlobalState*>* akGStack, std::vector<Light*>* pkLStack);


};