#include "Img.h"

std::vector<Img*> Img::images;

void Img::GetErrors()
{
	ILenum err;
	while ((err = ilGetError()) != IL_NO_ERROR)
	{
		switch(err)
		{
		case IL_INVALID_ENUM: std::cout << "IL_INVALID_ENUM" << std::endl;
			break;
		case IL_OUT_OF_MEMORY: std::cout << "IL_OUT_OF_MEMORY" << std::endl;
			break;
		case IL_FORMAT_NOT_SUPPORTED: std::cout << "IL_FORMAT_NOT_SUPPORTED" << std::endl;
			break;
		case IL_INTERNAL_ERROR: std::cout << "IL_INTERNAL_ERROR" << std::endl;
			break;
		case IL_INVALID_VALUE: std::cout << "IL_INVALID_VALUE" << std::endl;
			break;
		case IL_ILLEGAL_OPERATION: std::cout << "IL_ILLEGAL_OPERATION" << std::endl;
			break;
		case IL_ILLEGAL_FILE_VALUE: std::cout << "IL_ILLEGAL_FILE_VALUE" << std::endl;
			break;
		case IL_INVALID_FILE_HEADER: std::cout << "IL_INVALID_FILE_HEADER" << std::endl;
			break;
		case IL_INVALID_PARAM: std::cout << "IL_INVALID_PARAM" << std::endl;
			break;
		case IL_COULD_NOT_OPEN_FILE: std::cout << "IL_COULD_NOT_OPEN_FILE" << std::endl;
			break;
		case IL_INVALID_EXTENSION: std::cout << "IL_INVALID_EXTENSION" << std::endl;
			break;
		case IL_FILE_ALREADY_EXISTS: std::cout << "IL_FILE_ALREADY_EXISTS" << std::endl;
			break;
		case IL_OUT_FORMAT_SAME: std::cout << "IL_OUT_FORMAT_SAME" << std::endl;
			break;
		case IL_STACK_OVERFLOW: std::cout << "IL_STACK_OVERFLOW" << std::endl;
			break;
		case IL_STACK_UNDERFLOW: std::cout << "IL_STACK_UNDERFLOW" << std::endl;
			break;
		case IL_INVALID_CONVERSION: std::cout << "IL_INVALID_CONVERSION" << std::endl;
			break;
		case IL_LIB_JPEG_ERROR: std::cout << "IL_LIB_JPEG_ERROR" << std::endl;
			break;
		}
	} 
}

bool Img::LoadImg(ILenum Type, std::string FileName)
{	
	//std::string helper = "C:/Users/Michael/Documents/Visual Studio 2005/Projects/MyRenderer/MyRenderer/";
	//if(FileName.find(helper) != std::string::npos)	FileName = FileName.substr(helper.size());

	std::cout << "LOAD IMG: " << FileName << std::endl;
	ilEnable(IL_ORIGIN_SET);
	ilGenImages(1, & handle);
	ilBindImage(handle);
	const ILstring test = (const ILstring)FileName.c_str();
	
	ILboolean loaded = ilLoadImage(test);
	if (loaded == IL_FALSE) return false;

	width = ilGetInteger(IL_IMAGE_WIDTH); // getting image width
	height = ilGetInteger(IL_IMAGE_HEIGHT); // and height

	int memory_needed = width * height * 4 * sizeof(unsigned char);
	data = (ILubyte *)malloc(memory_needed);

	std::cout << "IMG WIDTH: " << width << " HEIGHT: " << height << std::endl;

	ilCopyPixels(0, 0, 0, width, height, 1, IL_RGBA, IL_UNSIGNED_BYTE, data);
	imageload = true;
	return true;
}

ILfloat* Img::LoadImgGetFloat(ILenum Type, std::string FileName, int& mwidth, int& mheight)
{	
	ILuint handle;

	std::string helper = "D:\\MyRenderer\\MyRenderer";
	if(FileName.find(helper) != std::string::npos)	FileName = FileName.substr(helper.size());

	std::cout << "LOAD IMG: " << FileName << std::endl;
	ilEnable(IL_ORIGIN_SET);
	ilGenImages(1, & handle);
	ilBindImage(handle);
	const ILstring test = (const ILstring)FileName.c_str();
	ILboolean loaded = ilLoadImage(test);
	
	if (loaded == IL_FALSE) return 0;

	if(mwidth > 0 && mheight > 0)
	{
		ilSetInteger(IL_IMAGE_WIDTH, mwidth); // getting image width
		ilSetInteger(IL_IMAGE_HEIGHT, mheight); // and height
	}
	else
	{	
		mwidth = ilGetInteger(IL_IMAGE_WIDTH); // getting image width
		mheight = ilGetInteger(IL_IMAGE_HEIGHT); // and height
	}

	int memory_needed = mwidth * mheight * 3 * sizeof(ILfloat);
	ILfloat* tmpdata = (ILfloat *)malloc(memory_needed);

	ilCopyPixels(0, 0, 0, mwidth, mheight, 1, IL_RGB, IL_FLOAT, tmpdata);
	ilBindImage(0);
	return tmpdata;
}


ILubyte* Img::GetData()
{
	return data;
}

bool Img::IsImageLoad()
{
	return imageload;
}

int Img::GetHeight()
{
	return (int) height;
}

int Img::GetWidth()
{
	return (int) width;
}