#include "Light.h"

Light::Light(void) : m_position(0.f,0.f,0.f), m_ambient(0.f,0.f,0.f,0.f), m_diffuse(1.f,1.f,1.f,1.f), m_specular(0.f,0.f,0.f,0.f), m_constant_attenuation(0.f), m_linear_attenuation(0.f), m_quadratic_attenuation(0.f), m_shineness(1.f)
{

}

Light::Light(glm::vec3 pos, glm::vec4 ambient, glm::vec4 diffuse, glm::vec4 specular) : m_position(pos), m_ambient(ambient), m_diffuse(diffuse), m_specular(specular), m_constant_attenuation(0.f), m_linear_attenuation(0.f), m_quadratic_attenuation(0.f), m_shineness(1.f)
{

}

Light::Light(glm::vec3 pos, glm::vec4 ambient, glm::vec4 diffuse, glm::vec4 specular, float shineness) : m_position(pos), m_ambient(ambient), m_diffuse(diffuse), m_specular(specular), m_constant_attenuation(0.f), m_linear_attenuation(0.f), m_quadratic_attenuation(0.f), m_shineness(shineness)
{

}

Light::Light(glm::vec3 pos, glm::vec4 ambient, glm::vec4 diffuse, glm::vec4 specular, float shineness, float constant_attenuation, float linear_attenuation, float quadratic_attenuation) : m_position(pos), m_ambient(ambient), m_diffuse(diffuse), m_specular(specular), m_constant_attenuation(constant_attenuation), m_linear_attenuation(linear_attenuation), m_quadratic_attenuation(quadratic_attenuation), m_shineness(shineness)
{

}

Light::~Light(void)
{
}

Camera* Light::GetCamera()
{
	return m_camera;
}

void Light::SetCamera(Camera* camera)
{
	m_camera = camera;
}

void Light::SetPosition(glm::vec3 pos)
{
	m_position = pos;
}

void Light::SetAmbient(glm::vec4 ambient)
{
	m_ambient = ambient;
}

void Light::SetDiffuse(glm::vec4 diffuse)
{
	m_diffuse = diffuse;
}

void Light::SetSpecular(glm::vec4 specular)
{
	m_specular = specular;
}
void Light::SetConstantAttenuation(float attenuation)
{
	m_constant_attenuation = attenuation;
}

void Light::SetLinearAttenuation(float attenuation)
{
	m_linear_attenuation = attenuation;
}

void Light::SetQuadraticAttenuation(float attenuation)
{
	m_quadratic_attenuation = attenuation;
}

void Light::SetShineness(float shineness)
{
	m_shineness = shineness;
}

glm::vec3 Light::GetPosition()
{
	return m_position;
}

glm::vec4 Light::GetAmbient()
{
	return m_ambient;
}

glm::vec4 Light::GetDiffuse()
{
	return m_diffuse;
}

glm::vec4 Light::GetSpecular()
{
	return m_specular;
}

float Light::GetConstantAttenuation()
{
	return m_constant_attenuation;
}

float Light::GetLinearAttenuation()
{
	return m_linear_attenuation;
}

float Light::GetQuadraticAttenuation()
{
	return m_quadratic_attenuation;
}

float Light::GetShineness()
{
	return m_shineness;
}