#pragma once
/*! \mainpage Kinetic Visualization
 *  \image html particles_2.png
 * \section autors_sec Autoren 
 * <p>Michael Beham <br />
 * 0726417<br />
 * 066 932</p>
 * <p>Caroline Steiner<br />
 * 0525945<br />
 * 066 932</p>
 *
 *
 * \section intro_sec Aufgabenstellung
 *
 * <p>Die Aufgabenstellung dieses Programmes lag darin ein Paper auszusuchen und zu implementiern. Wir haben uns fr Kinetic Visualization entschieden. In dem Paper geht es darum Partikeln ber ein Volumen gleiten zu lassen, um bessere visuelle Hinweise zu Oberflchenstruktur zu erhalten.
 *
 * \section features_sec Features
 *  @li Volume Rendering:
 *  @li Compositing
 *  @li Maximum Intensity Projection
 *  @li X-Ray
 *  @li Phong-Beleuchtung
 *  @li HDR
 *  @li PartikelBewegung:
 *  @li Gradienten
 *  @li Curvature
 *  @li Flocking
 *  @li Predefined Direction
 *  @li Fluid Simulation
 *  @li Interactive Transferfunktionen fr Volumen und Partikel
 *  @li Clustering
 *  @li Fast higher order filtering
 *  @li Volumne Bricking
 *
 * \section download_sec Download
 * Das Programm, knnen Sie <a href="release.zip">hier</a> downloaden. Den Quellcode  <a href="src.zip">hier</a>. Sowie Daten <a href="data.zip">hier</a>
 *
 */

/*! \page gui_control Bedienung
* \section gui GUI
* <p>Nach Starten des Programms sieht man das User Interface mit mehreren Interaktionsmglichkeiten. <br />
* \image html sc4.PNG
* Der erste Schritt ist nun das laden eines Datensatzes, dies erfolgt indem man oben links ber das \"File\" \> \"Open\" einen Datensatz auswhlt. <br />
* \image html open.png
* Es knnen folgende Daten geffnet werden
* @li .dat
* </p> 
* <p> Wenn der Datensatz nun geladen ist, knnen mehrer Eingabeparameter verndert werden. Dafr gibt es 4 Tabs <br /> 
* @li Slicing
* @li Volume Rendering
* @li Particles
* @li Fluid
*
* \section interaction_sec Interaction Layout
*
* <p> Folgende Einstellungen kann mann ndern 
*
* <table>
* <tr>
* <th> Gui-Element </th>
* <th> Description </th>
* <th> Beispiel </th>
* </tr>
* <tr>
* <td>
* \image html VolumeRendering.PNG
* </td>
* <td> Hier knnen die Parameter bezglich Volumen Rendering eingestellt werden. <br /> Es knnen die Verfahren gewlt werden. <br /> Das Licht ein und augeschalten. <br /> so wie weitere Einstellungen</td>
* <td> 
* \image html shading.PNG
* </td>
* </tr>
* <tr>
* <td>
* \image html Particles.PNG
* </td>
* <td> Hier knnen die Parameter fr die Partikel ausgewhlt werden. <br /> Wie z.B. Gre, Geschwindigkeit und Anzahl. <br /> Ebenso knnen die Bewegung der Partikel ausgewhlt werden wie z.B. Curvature <br /> Bei der Bewegungen ist auch mehrfach Auswahl mglich. </td>
* <td> 
* \image html particles_pic.PNG
* </td>
* </tr>
* <tr>
* <td>
* \image html Fluid.PNG
* </td>
* <td> Hier knnen die Parameter fr die Fluid-Simulation eingestellt werden. <br /> Hier knnen ebenfalls die Partikel Gre und Anzahl eingestellt werden.  <br />  Weitere Parameter sind Particel mass/Gravity/Shiftness.  </td>
* <td> 
* \image html particles3.PNG
* </td>
* </tr>
* </table>
* \section tf_sec Interaction Transferfunktion
* <p> Die Transferfunktion kann interaktiv eingestellt werden:
* @li Die Farbe kann im Farbrad neben der Transferfunktion durch klicken ausgewhlt werden.
* @li Neue Punkte knnen mit einem links Klick eingefgt werden.
* @li Bestehende Punkte knnen durch rechts Klick wieder gelscht werden.
* @li Bestehende Punkte knnen mit gehaltenem links Klick verschobe werden.
* </p>
*
* \section camera_sec Interaction Camera
*
* <p> Die Camera kann bewegt werden mittels 
* @li Mausrad : Zoom
* @li Rechte Maustaste halten + Bwegen: Zoom
* @li Linke Maustaste : Rotation
* </p>
*
*\page pictures Bilder
* Im Folgenden sehen Sie ein paar Ergebnisse dieses Programmes:
*  \image html particles_2.png
*  \image html particles_pic.png
*  \image html particles3.png
*  \image html shading.png
*  \image html xray.png
*  \image html mip.png
*
*
*\page implementation Implementierung
* <p>Dieses Progamm wurde in C++, Cuda, Open GL und GLSL implementiert. Die GUI wurde mithilfe von QT implementiert.</p>
* <p>Das Programm wurde in verschiedene Bereiche untergliedert. Nmlich:
* @li GUI, 
* @li Renderer, 
* @li Partikelsystem,
* </p>
*
* <p>Die GUI wurde mithilfe von QT und den QT Designer erstellt. Dadurch werden in MainWindow nur noch Slots zum laden der QUI Werte bentigt, welche weiters mit einer einfachen statischen Klasse (Renderstates) an den Renderer weitergegeben werden.</p>
* <p>Die Particle werden mithilfe von CUDA berechnet, aber anschlieend mittels OpenGL gerendert. Der Vorteil dieser Methode ist, dass die jeweiligen Vorteile beider Systeme optimal berechnet werden. Die Regeln sind groteils 1zu1 umgesetzt worden (bei Fluid und Partikel). Spannend ist die Grid Methode, welche zur Berechnung der nchsten Nachbarn bentzt wird. Dazu wird ein Grid eingefhrt (uniform verteilt), welches jedes ein Index hat. Desweiteren hat auch jedes Partikel ein Index. Anschlieend speichert jedes Partikel den Index in das zugehrige Grid Index. Anschlieend wird nach dem Gridindex sortiert. Die Partikeln werden anhand diesen Indexes sortiert und es kann dazu noch der Grid Start und Endindex berechnet werden.</p>
* <p>Die Darstellung wird im Rendering Teil erstellt. Es wurden verschiedene Renderingpasses erstellt, nmlich fr
* @li HDR
* @li Darstellung der Particle
* @li und Raycasting
*
* Spannend ist auch, dass einige Mglichkeiten zum Rendering existieren
* @li Contour Rendering
* @li Sichtbarkeit abhngig der Spekulren Reflexion
* @li MIP
* @li Averaging
* </p>
*
* <p>Das Raycasting wurde mittels Volume Bricking optimiert um teure Rechenzeit zu sparen.</p>
*
* <p>
* Desweiteren wurde auch 2 Clustering Algorithmen implementiert. Nmlich: EM Algorithmus of Multple Gaussians, sowie kMeans Algorithmus.
* Diese werden im Gegensatz zur restlichen Funktionen, welche parallel auf der GPU berechnet wurden, parallel auf der CPU berechnet. Es werden auch 2D Transferfunktionen untersttzt. 
* </p> 
*
* 
*\section technologies_sec Technologien
* Technologien:
*  @li (Visual Stuio) C++
*  @li OpenGL mit GLSL
*  @li GLEW, QT
*  @li GLM
*  @li Cuda
*  @li boost
*  @li ALGLIB
*
*\page references Referenzen
* Referenzen:
*  @li <b>[1]</b> Lum et al., "Kinetic Visualization - A Technique for Illustrating 3D Shape and Structure", IEEE VISUALIZATION 2002, Conference Publications 
*  @li <b>[2]</b> Christian Sigg, Markus Hadwiger, "Chapter 20. Fast Third-Order Texture Filtering", GPU Gems 2
*  @li <b>[3]</b> Christian Luksch,  "Realtime HDR Rendering", Tu Wien, Projektpraktikum mit Bakkalaureatsarbeit, 2006/2007
*  @li <b>[4]</b> Z Horvth,  "Real-time particle simulation of fluids",  2012 (CESCG)
*  @li <b>[5]</b> Marc Levoy, "Display of Surfaces from Volume Data", IEEE Computer Graphics and Applications, Vol. 8(3), pp. 29-37, Feb.1987 
*  @li <b>[6]</b> Lszl Neumann, Balzs Csbfalvi, Andreas Knig, Eduard Grller, "Gradient Estimation in Volume Data using 4D Linear Regression", EUROGRAPHICS 2000, Volume 19 (2000), Number 3
*  @li <b>[7]</b> Stefan Bruckner, Sren Grimm, Armin Kanitsar, and M. Eduard Grller, "Illustrative Context-Preserving Exploration of Volume Data", IEEE Transactions on Visualization and Computer Graphics, Vol. 12, NO. 6, November/December 2006
*  @li <b>[8]</b> Balzs Csbfalvi, Lukas Mroz, Helwig Hauser, Andreas Knig, and Eduard Grller, "Fast Visualization of Object Contours by Non-Photorealistic Volume Rendering", EUROGRAPHICS 2001, Volume 20 (2001), Number 3, 2001
*  @li <b>[9]</b> Simon Green, "Particle Simulation using CUDA", Nvidia, 2010
*/

#include "ui_mainWindow.h"
#include <QMainWindow>
#include <QString>
#include <QProgressDialog>


class MainWindow : public QMainWindow, public Ui::MainWindow
{
	Q_OBJECT

public:
	/** The constructor. */
	MainWindow(QWidget* parent = 0);
	/** The destructor. */
	~MainWindow();
	/** Used to show the progress of loading, preparing a file */
	QProgressDialog* pd;

signals:
	/** This Signal is emitted when a new Volum has been loaded */
	void volumeLoaded();
	/** This Signal is emitted when a Transferfunction is applied to the Volum */
	void applyTransferFunction(float* data, int size, int mode);
	/** This Signal is emitted when the TransferFunctionWidget is shown and the Colorgradient is visibel */
	void applyColorgradient(float* data, int size, int mode);
	/** This Signal is emitted when the Transferfunction has to be deleted*/
	void resetTransferFunction();
	/** This Signal is emitted when the Colorgradient has to be reseted */
	void resetColorgradient();

	/**
	 * Called when number of clusters is changed
	 * @param k new number of clusters
	 **/
	void DoingClustering(int k);

	/**
	 * Called when  rendering mode is changed 
	 * @param s new rendering mode
	 **/
	void valuesMode(int s);
	/**
	 * Called when action object is changed
	 * @param s new action object
	 **/
	void setActionObjectType(int s);

	/**
	 * Called when iso value is changed
	 * @param v new value
	 **/
	void SetIsoSurfaceChanged(float v);

private slots:
	/** To load a Volum from a file*/ 
	void openFileDialog();
	/** To save a screenshot */
	void saveFileDialog();
	/** To save a Transferfunction */
	void saveTransferFunction();
	/** To load a Transferfunction */
	void loadTransferFunction();
	/** To reset the Transferfunction to default.
	*	So that you dont have to delet every Point yourself.
	*/
	void resetTransferFunctionButton();
	/** 
	*	To show, hide the TransferFunctionWidget
	*	@param state indicates if "show transferfunktion" has been selected.
	*/
	void showTransferFunctionClicked(int state);
	/**
	*	Applies the Transferfunction to the Volum 	
	*	@param state indicates if "apply transferfunktion" has been selected.
	*/
	void applyTranferFunctionClicked(int state);
	/**
	*	Applies the Transferfunction to the Volum 	
	*	@param state indicates if "apply transferfunktion" has been selected.
	*/
	void applyTranferFunctionClicked(bool state);

	/**
	*	Tab changes => changes in rendering 	
	*	@param value id of current tab
	*/
	void TabIndexChanged(int value);

	/**
	*	Called when gradient value changes
	*	@param value new value
	*/
	void gradientChanged(int value);
	/**
	*	Called when curvature value changes
	*	@param value new value
	*/
	void curvatureChanged(int value);
	/**
	*	Called when flocking vector changes
	*	@param value new value
	*/
	void flockingChanged(int value);
	/**
	*	Called when predefined vector value changes
	*	@param value new value
	*/
	void predefinedChanged(int value);
	/**
	*	Called when density value changes
	*	@param value new value
	*/
	void densityChanged(int value);

	/**
	*	Called when gradient radio botton pressed
	*	@param value true... clicked
	*/
	void gradientEnabled(bool);
	/**
	*	Called when curvature radio botton pressed
	*	@param value true... clicked
	*/
	void curvatureEnabled(bool);
	/**
	*	Called when curvature radio botton pressed other eigenvector version
	*	@param value true... clicked
	*/
	void CurvaturEnabled2(bool);
	/**
	*	Called when flocking vector radio botton pressed
	*	@param value true... clicked
	*/
	void flockingEnabled(bool);
	/**
	*	Called when predefined vector radio botton pressed
	*	@param value true... clicked
	*/
	void predefinedEnabled(bool);
	/**
	*	Called when density radio botton pressed
	*	@param value true... clicked
	*/
	void densityEnabled(bool);

	/**
	*	not used now
	*/
	void fluidDenstiyEnabled(bool);
	/**
	*	not used now
	*/
	void fluidViscosityEnabled(bool);
	/**
	*	not used now
	*/
	void fluidPressureEnabled(bool);
	/**
	*	Called when collsion radio botton pressed
	*	@param value true... clicked
	*/
	void fluidCollisionEnabled(bool);
	/**
	*	Called when collsion CT radio botton pressed
	*	@param value true... clicked
	*/
	void fluidCollisionCTEnabled(bool);

	/**
	*	Called when spring value is changed
	*	@param v spring value
	*/
	void fluidSpringChanged(double v);
	/**
	*	Called when damping value is changed
	*	@param v damping value
	*/
	void fluidDampingChanged(double v);
	/**
	*	Called when shear value is changed
	*	@param v shear value
	*/
	void fluidShearChanged(double v);
	/**
	*	Called when spring CT value is changed
	*	@param v spring value
	*/
	void fluidSpringCTChanged(double v);
	/**
	*	Called when damping CT value is changed
	*	@param v damping value
	*/
	void fluidDampingCTChanged(double v);
	/**
	*	Called when shear CT value is changed
	*	@param v shear value
	*/
	void fluidShearCTChanged(double v);

	/**
	*	Called when particle mass value is changed
	*	@param v particle mass
	*/
	void fluidParticleMass(double v);
	/**
	*	Called when viscosity value is changed
	*	@param v viscosity
	*/
	void fluidViscosity(double v);
	/**
	*	Called when siftness value is changed
	*	@param v siftness
	*/
	void fluidSiftness(double v);
	/**
	*	Called when rest density mass value is changed
	*	@param v rest density mass
	*/
	void fluidRestdensity(double v);

	/**
	*	Called when gravity value is changed
	*	@param v gravity
	*/
	void particleGravityChanged(double v);

	/**
	*	Called when Transferfunction Mode is changed
	*	@param val type of TF
	*/
	void TransferFunctionIndexChanged(int val);

	/**
	*	Called when Selecting mode is enabled
	*	@param val number of clusters
	*/
	void SelectObjects(bool v);
	
	/**
	*	Called when draw points is enabled
	*	@param val number of clusters
	*/
	void DrawPoints(bool v);
	/**
	*	Called when draw rectangle mode is enabled.
	*	@param val number of clusters
	*/
	void DrawRectangles(bool v);
	/**
	*	Called when draw ellipse mode is enabled.
	*	@param val number of clusters
	*/
	void DrawEllipse(bool v);

	/**
	*	Called when Number of Clusters are changed
	*	@param val number of clusters
	*/
	void numberClusterChanged(int);
	/**
	*	Called when Clustering button is pressed
	*	@param val true...start clustering
	*/
	void doClustering(bool val);

	/**
	*	Called when particle size value is changed
	*	@param val particle value
	*/
	void particleSize(int val);
	/**
	*	Called when number of particles value is changed
	*	@param val number of particles
	*/
	void SetNumberOfParticles(int val);

	/**
	*	Called when particle speed value is changed
	*	@param val particle speed
	*/
	void particleSpeedSlider(int val);
	/**
	*	Called when particle speed value is changed
	*	@param val particle val
	*/
	void particleSpeed(double val);

	/**
	*	Callend when Reset botton is enabled
	*	@param value true... clicked
	*/
	void Reset(bool);
	/**
	*	Callend when Play botton is enabled
	*	@param value true... clicked
	*/
	void Play(bool);

	/**
	*	Callend when hdr mode is enabled
	*	@param value true... clicked
	*/
	void HdrEnable(bool);
	/**
	*	Callend when linear function is enabled
	*	@param value true... clicked
	*/
	void HDRLinear(bool);
	/**
	*	Callend when Reinhard function is enabled
	*	@param value true... clicked
	*/
	void HDRReinhard(bool);
	/**
	*	Callend when modified Reinhard function is enabled
	*	@param value true... clicked
	*/
	void HDRReinhardModified(bool);
	/**
	*	Callend when addaptive function is enabled
	*	@param value true... clicked
	*/
	void HDRAdaptivLog(bool);

	/**
	*	Callend when standard mode is enabled
	*	@param value true... clicked
	*/
	void StandardModus(bool val);
	/**
	*	Callend when contour mode is enabled
	*	@param value true... clicked
	*/
	void ContourModus(bool val);
	/**
	*	Callend when exposure mode is enabled
	*	@param value true... clicked
	*/
	void ExposureModus(bool val);

	/**
	 * Called when ISO value is changed
	 * @param val new iso value
	 **/
	void IsoSurfaceChanged(int val);


private:
	int m_mode;
	int m_num_cluster;
};