#include "Material.h"

Material::Material() : m_shininess(1), m_emissive(0.f,0.f,0.f,1.f), m_ambient(0.2f,0.2f,0.2f,1.f), m_diffuse(0.8f,0.8f,0.8f,1.f), m_specular(1.0f,1.0f,1.0f,1.f)
{

}

Material::Material(glm::vec4 emissive, glm::vec4 ambient, glm::vec4 diffuse, glm::vec4 specular, float shininess) : m_emissive(emissive), m_ambient(ambient), m_diffuse(diffuse), m_specular(specular), m_shininess(shininess)
{
}


Material::~Material(void)
{
}

void Material::SetEmissive(glm::vec4 emissive)
{
	m_emissive = emissive;
}

void Material::SetAmbient(glm::vec4 ambient)
{
	m_ambient = ambient;
}

void Material::SetDiffuse(glm::vec4 diffuse)
{
	m_diffuse = diffuse;
}

void Material::SetSpecular(glm::vec4 specular)
{
	m_specular = specular;
}

void Material::SetShininess(float shininess)
{
	m_shininess = shininess;
}

glm::vec4 Material::GetEmissive()
{
	return m_emissive;
}

glm::vec4 Material::GetAmbient()
{
	return m_ambient;
}

glm::vec4 Material::GetDiffuse()
{
	return m_diffuse;
}

glm::vec4 Material::GetSpecular()
{
	return m_specular;
}
float Material::GetShininess()
{
	return m_shininess;
}