#include "Primitives.h"
#include "common.hpp"

Primitives::Primitives(void)
{

}

Primitives::~Primitives(void)
{
}
VertexGeometry* Primitives::GetPlane()
{
	glm::vec4* vertices = new glm::vec4[4];
	vertices[0] = glm::vec4(-1.f,-1.f, 0.f, 1.f);
	vertices[1] = glm::vec4(-1.f, 1.f, 0.f, 1.f);
	vertices[2] = glm::vec4( 1.f, 1.f, 0.f, 1.f);
	vertices[3] = glm::vec4( 1.f,-1.f, 0.f, 1.f);

	glm::vec3* normals = new glm::vec3[4];
	normals[0] = glm::vec3( 0.f, 0.f, 1.f);
	normals[1] = glm::vec3( 0.f, 0.f, 1.f);
	normals[2] = glm::vec3( 0.f, 0.f, 1.f);
	normals[3] = glm::vec3( 0.f, 0.f, 1.f);

	glm::vec2* texcoords = new glm::vec2[4];
	texcoords[0] = glm::vec2( 0.f, 0.f);
	texcoords[1] = glm::vec2( 0.f, 1.f);
	texcoords[2] = glm::vec2( 1.f, 1.f);
	texcoords[3] = glm::vec2( 1.f, 0.f);

	glm::vec4* colors = new glm::vec4[4];
	colors[0] = glm::vec4( 1.f, 1.f, 1.f, 1.f);
	colors[1] = glm::vec4( 1.f, 1.f, 1.f, 1.f);
	colors[2] = glm::vec4( 1.f, 1.f, 1.f, 1.f);
	colors[3] = glm::vec4( 1.f, 1.f, 1.f, 1.f);

	int* trigs = new int[6];
	trigs[0] = 0; trigs[1] = 1; trigs[2] = 2;
	trigs[3] = 0; trigs[4] = 2; trigs[5] = 3;

	VertexGeometry* geo = new VertexGeometry(vertices, normals, texcoords, 0, 0, trigs, 4, 6);
	return geo;
}

VertexGeometry* Primitives::GetPlane2()
{
	glm::vec4* vertices = new glm::vec4[4];
	vertices[0] = glm::vec4( 0.f, 0.f, 0.f, 1.f);
	vertices[1] = glm::vec4( 0.f, 0.f, 1.f, 1.f);
	vertices[2] = glm::vec4( 1.f, 0.f, 1.f, 1.f);
	vertices[3] = glm::vec4( 1.f, 0.f, 0.f, 1.f);

	glm::vec3* normals = new glm::vec3[4];
	normals[0] = glm::vec3( 0.f, 0.f, 1.f);
	normals[1] = glm::vec3( 0.f, 0.f, 1.f);
	normals[2] = glm::vec3( 0.f, 0.f, 1.f);
	normals[3] = glm::vec3( 0.f, 0.f, 1.f);

	glm::vec2* texcoords = new glm::vec2[4];
	texcoords[0] = glm::vec2( 0.f, 0.f);
	texcoords[1] = glm::vec2( 0.f, 1.f);
	texcoords[2] = glm::vec2( 1.f, 1.f);
	texcoords[3] = glm::vec2( 1.f, 0.f);

	glm::vec4* colors = new glm::vec4[4];
	colors[0] = glm::vec4( 1.f, 1.f, 1.f, 1.f);
	colors[1] = glm::vec4( 1.f, 1.f, 1.f, 1.f);
	colors[2] = glm::vec4( 1.f, 1.f, 1.f, 1.f);
	colors[3] = glm::vec4( 1.f, 1.f, 1.f, 1.f);

	int* trigs = new int[6];
	trigs[0] = 0; trigs[1] = 1; trigs[2] = 2;
	trigs[3] = 0; trigs[4] = 2; trigs[5] = 3;

	VertexGeometry* geo = new VertexGeometry(vertices, normals, texcoords, 0, 0, trigs, 4, 6);
	return geo;
}


VertexGeometry* Primitives::GetBox()
{
	glm::vec4* vertices = new glm::vec4[8];
	
	vertices[0] = glm::vec4( 0.f, 0.f, 0.f, 1.f);
	vertices[1] = glm::vec4( 0.f, 0.f, 1.f, 1.f);
	vertices[2] = glm::vec4( 0.f, 1.f, 0.f, 1.f);
	vertices[3] = glm::vec4( 0.f, 1.f, 1.f, 1.f);
	vertices[4] = glm::vec4( 1.f, 0.f, 0.f, 1.f);
	vertices[5] = glm::vec4( 1.f, 0.f, 1.f, 1.f);
	vertices[6] = glm::vec4( 1.f, 1.f, 0.f, 1.f);
	vertices[7] = glm::vec4( 1.f, 1.f, 1.f, 1.f);

	glm::vec3* normals = new glm::vec3[8];
	normals[0] = glm::vec3(-1.f,-1.f,-1.f);
	normals[1] = glm::vec3(-1.f,-1.f, 1.f);
	normals[2] = glm::vec3(-1.f, 1.f,-1.f);
	normals[3] = glm::vec3(-1.f, 1.f, 1.f);
	normals[4] = glm::vec3( 1.f,-1.f,-1.f);
	normals[5] = glm::vec3( 1.f,-1.f, 1.f);
	normals[6] = glm::vec3( 1.f, 1.f,-1.f);
	normals[7] = glm::vec3( 1.f, 1.f, 1.f);

	glm::vec2* texcoords = new glm::vec2[8];
	texcoords[0] = glm::vec2( 0.f, 0.f);
	texcoords[1] = glm::vec2( 0.f, 1.f);
	texcoords[2] = glm::vec2( 0.f, 0.f);
	texcoords[3] = glm::vec2( 0.f, 1.f);
	texcoords[4] = glm::vec2( 1.f, 0.f);
	texcoords[5] = glm::vec2( 1.f, 1.f);
	texcoords[6] = glm::vec2( 1.f, 0.f);
	texcoords[7] = glm::vec2( 1.f, 1.f);

	glm::vec4* colors = new glm::vec4[8];
	colors[0] = glm::vec4( 0.f, 0.f, 0.f, 1.f);
	colors[1] = glm::vec4( 0.f, 0.f, 1.f, 1.f);
	colors[2] = glm::vec4( 0.f, 1.f, 0.f, 1.f);
	colors[3] = glm::vec4( 0.f, 1.f, 1.f, 1.f);
	colors[4] = glm::vec4( 1.f, 0.f, 0.f, 1.f);
	colors[5] = glm::vec4( 1.f, 0.f, 1.f, 1.f);
	colors[6] = glm::vec4( 1.f, 1.f, 0.f, 1.f);
	colors[7] = glm::vec4( 1.f, 1.f, 1.f, 1.f);

	int* trigs = new int[36];
	trigs[0] = 6; trigs[1] = 2; trigs[2] = 3;
	trigs[3] = 6; trigs[4] = 3; trigs[5] = 7;
	trigs[6] = 5; trigs[7] = 1; trigs[8] = 0;
	trigs[9] = 5; trigs[10] = 0; trigs[11] = 4;
	trigs[12] = 7; trigs[13] = 3; trigs[14] = 1;
	trigs[15] = 7; trigs[16] = 1; trigs[17] = 5;
	trigs[18] = 4; trigs[19] = 0; trigs[20] = 2;
	trigs[21] = 4; trigs[22] = 2; trigs[23] = 6;
	trigs[24] = 3; trigs[25] = 2; trigs[26] = 0;
	trigs[27] = 3; trigs[28] = 0; trigs[29] = 1;
	trigs[30] = 6; trigs[31] = 7; trigs[32] = 5;
	trigs[33] = 6; trigs[34] = 5; trigs[35] = 4;

	VertexGeometry* geo = new VertexGeometry(vertices, normals, colors, texcoords, 0, 0, trigs, 8, 36);
	return geo;
}

VertexGeometry* Primitives::GetBox2()
{
	glm::vec4* vertices = new glm::vec4[8];
	
	vertices[0] = glm::vec4( 0.f, 0.f, 0.f, 1.f);
	vertices[1] = glm::vec4( 0.f, 0.f, 1.f, 1.f);
	vertices[2] = glm::vec4( 0.f, 1.f, 0.f, 1.f);
	vertices[3] = glm::vec4( 0.f, 1.f, 1.f, 1.f);
	vertices[4] = glm::vec4( 1.f, 0.f, 0.f, 1.f);
	vertices[5] = glm::vec4( 1.f, 0.f, 1.f, 1.f);
	vertices[6] = glm::vec4( 1.f, 1.f, 0.f, 1.f);
	vertices[7] = glm::vec4( 1.f, 1.f, 1.f, 1.f);

	glm::vec3* normals = new glm::vec3[8];
	normals[0] = glm::vec3(-1.f,-1.f,-1.f);
	normals[1] = glm::vec3(-1.f,-1.f, 1.f);
	normals[2] = glm::vec3(-1.f, 1.f,-1.f);
	normals[3] = glm::vec3(-1.f, 1.f, 1.f);
	normals[4] = glm::vec3( 1.f,-1.f,-1.f);
	normals[5] = glm::vec3( 1.f,-1.f, 1.f);
	normals[6] = glm::vec3( 1.f, 1.f,-1.f);
	normals[7] = glm::vec3( 1.f, 1.f, 1.f);

	glm::vec2* texcoords = new glm::vec2[8];
	texcoords[0] = glm::vec2( 0.f, 0.f);
	texcoords[1] = glm::vec2( 0.f, 1.f);
	texcoords[2] = glm::vec2( 0.f, 0.f);
	texcoords[3] = glm::vec2( 0.f, 1.f);
	texcoords[4] = glm::vec2( 1.f, 0.f);
	texcoords[5] = glm::vec2( 1.f, 1.f);
	texcoords[6] = glm::vec2( 1.f, 0.f);
	texcoords[7] = glm::vec2( 1.f, 1.f);

	glm::vec4* colors = new glm::vec4[8];
	colors[0] = glm::vec4( 0.f, 0.f, 0.f, 1.f);
	colors[1] = glm::vec4( 0.f, 0.f, 1.f, 1.f);
	colors[2] = glm::vec4( 0.f, 1.f, 0.f, 1.f);
	colors[3] = glm::vec4( 0.f, 1.f, 1.f, 1.f);
	colors[4] = glm::vec4( 1.f, 0.f, 0.f, 1.f);
	colors[5] = glm::vec4( 1.f, 0.f, 1.f, 1.f);
	colors[6] = glm::vec4( 1.f, 1.f, 0.f, 1.f);
	colors[7] = glm::vec4( 1.f, 1.f, 1.f, 1.f);

	int* trigs = new int[36];
	trigs[0] = 6; trigs[1] = 3; trigs[2] = 2;
	trigs[3] = 6; trigs[4] = 7; trigs[5] = 3;
	trigs[6] = 5; trigs[7] = 0; trigs[8] = 1;
	trigs[9] = 5; trigs[10] = 4; trigs[11] = 0;
	trigs[12] = 7; trigs[13] = 1; trigs[14] = 3;
	trigs[15] = 7; trigs[16] = 5; trigs[17] = 1;
	trigs[18] = 4; trigs[19] = 2; trigs[20] = 0;
	trigs[21] = 4; trigs[22] = 6; trigs[23] = 2;
	trigs[24] = 3; trigs[25] = 0; trigs[26] = 2;
	trigs[27] = 3; trigs[28] = 1; trigs[29] = 0;
	trigs[30] = 6; trigs[31] = 5; trigs[32] = 7;
	trigs[33] = 6; trigs[34] = 4; trigs[35] = 5;

	VertexGeometry* geo = new VertexGeometry(vertices, normals, colors, texcoords, 0, 0, trigs, 8, 36);
	return geo;
}

VertexGeometry* Primitives::GetSphere()
{
	unsigned int slicesX = 50;
	unsigned int slicesY = 50;

	glm::vec4* vertices = new glm::vec4[slicesX*slicesY];
	glm::vec3* normals = new glm::vec3[slicesX*slicesY];
	glm::vec2* texcoords = new glm::vec2[slicesX*slicesY];
	int* index = new int[slicesX*slicesY*6];

	int it = 0;
	for(unsigned int i = 0; i < slicesX; i++)
	{
		for(unsigned int j = 0; j < slicesY; j++)
		{
			vertices[it] = glm::vec4(	sinf((float)i/(float)slicesX*PI*2.f)*cosf((float)j/(float)slicesY*PI*2.f), sinf((float)i/(float)slicesX*PI*2.f)*sinf((float)j/(float)slicesY*PI*2.f), cosf((float)i/(float)slicesX*PI*2.f),1.0f);
			normals[it]= glm::normalize(glm::vec3(vertices[it].x, vertices[it].y, vertices[it].z));	//Sphere wird um dem Mittelpunkt erzeugt
			texcoords[it] = glm::vec2((float)i/(float)slicesX, (float)j/(float)slicesY);
			it++;
		}
	}

	it = 0;
	for(unsigned int i = 1; i <= slicesX; i++)
	{
		for(unsigned int j = 1; j <= slicesY; j++)
		{
			index[it] = ((i-1)*slicesX)+(j-1);				it++;
			index[it] = ((i-1)*slicesX)+(j%slicesY);		it++;
			index[it] = ((i%slicesX)*slicesX)+(j-1);		it++;

			index[it] = ((i-1)*slicesX)+(j%slicesY);		it++;
			index[it] = ((i%slicesX)*slicesX)+(j-1);		it++;
			index[it] = ((i%slicesX)*slicesX)+(j%slicesY);	it++;
		}
	}
	std::cout << "trigs created" << std::endl;

	VertexGeometry* geo = new VertexGeometry(vertices, normals, texcoords, 0, 0, index, slicesX*slicesY, slicesX*slicesY*6);
	return geo;
}