#pragma once
class RenderStates
{
public:
	RenderStates(void);
	~RenderStates(void);

public:
	/** Modus changed **/
	static int ModusChanged;

	/** Particles gradient rule enabled**/
	static bool ParticleGradientEnable;
	/** Particles curvatur rule enabled**/
	static bool ParticleCurvatureEnable;
	/** Particles flocking rule enabled**/
	static bool ParticleFlockingEnable;
	/** Particles predefined rule enabled**/
	static bool ParticlePredefinedEnable;
	/** Particles density rule enabled**/
	static bool ParticleDensityEnable;

	/** Particles gradient weight**/
	static float ParticleGradientValue;
	/** Particles curvature weight**/
	static float ParticleCurvatureValue;
	/** Particles flocking weight**/
	static float ParticleFlockingValue;
	/** Particles predefined weight**/
	static float ParticlePredefinedValue;
	/** Particles density weight**/
	static float ParticleDensityValue;

	/** Fluid collision detection enabled**/
	static bool FluidCollisionEnable;
	/** Fluid collision detection with CT enabled**/
	static bool FluidCollisionCTEnable;

	/** Gravity of Fluid**/
	static float FluidParticleGravity;
	/** Mass of Fluid**/
	static float FluidParticleMass;
	/** Viscosity of Fluid**/
	static float FluidViscosity;
	/** Siftness of Fluid**/
	static float FluidSiftness;
	/** Restdenstiy of Fluid**/
	static float FluidRestdensity;
	/** Gravity of Fluid**/
	static float FluidGravity;

	/** Spring value of Fluid**/
	static float FluidSpringValue;
	/** Damping value of Fluid**/
	static float FluidDampingValue;
	/** Shear value of Fluid**/
	static float FluidShearValue;
	/** Spring value of Fluid**/
	static float FluidSpringCTValue;
	/** Damping value of Fluid**/
	static float FluidDampingCTValue;
	/** Shear value of Fluid**/
	static float FluidShearCTValue;
	
	/** 1= Compositing modes **/
	static int Compositing;
	/** 1= rendermode enable **/
	static int RenderMode;
	/** 1= addaptive enable **/
	static int Addaptive;
	/** 1= stepsize enable **/
	static float Stepsize;
	/** 1= MIP enable **/
	static int MIP;
	/** 1= transferfunction enable **/
	static int Transfer;
	/** 1= average enable **/
	static int Average;
	/** 1= Light enable **/
	static int Light;
	/** 1= phong enable **/
	static int Phong;

	/** Particle speed **/
	static float ParticleSpeed;
	/** Particle size **/
	static float ParticleSize;
	/** Number of particles **/
	static int NumberOfParticles;

	/** Play **/
	static bool Play;
	/** Reset **/
	static bool Reset;

	/** HDR is enable **/
	static int HDREnable;

	/** HDR mode **/
	static int HDRMode;

	/** Other eigenvectors mode **/
	static bool ParticleCurvature2Enable;

	/** ISO Value**/
	static float IsoSurface;
};

