#include "RendererOpenGL.h"


RendererOpenGL::RendererOpenGL(void)
{
}


RendererOpenGL::~RendererOpenGL(void)
{
}

void RendererOpenGL::ClearColorBuffer()
{
	glClear(GL_COLOR_BUFFER_BIT);
}

void RendererOpenGL::ClearDepthBuffer()
{
	glClear(GL_DEPTH_BUFFER_BIT);
}

void RendererOpenGL::ClearStencilBuffer()
{
	glClear(GL_STENCIL_BUFFER_BIT);
}

void RendererOpenGL::ClearAccumBuffer()
{
	glClear(GL_ACCUM_BUFFER_BIT);
}

void RendererOpenGL::SetClearColor(glm::vec4 color)
{
	glClearColor(color.r, color.g, color.b, color.a);
}

void RendererOpenGL::SwapBuffer()
{
	
}

void RendererOpenGL::GetErrors()
{
	//Get Open GL Errors
	get_errors();
}

void RendererOpenGL::SetFrontCulling()
{
	glCullFace(GL_FRONT);
}

void RendererOpenGL::SetBackCulling()
{
	glCullFace(GL_BACK);
}

void RendererOpenGL::EnableBackFaceCulling()
{	
	glEnable(GL_CULL_FACE);
}

void RendererOpenGL::DisableBackFaceCulling()
{
	glDisable(GL_CULL_FACE);
}

void RendererOpenGL::DrawGeometrySpecificUniforms()
{
	for(int i = 0; m_pkGeometry->m_shader_uniforms.size() > m_view->GetPass() && i < m_pkGeometry->m_shader_uniforms[m_view->GetPass()].size(); i++)
	{
		switch(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_type)
		{
		case ShaderObj::PT_FLOAT:	//std::cout << "PT_FLOAT:" << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0] << std::endl;
									//glUniform1fv(m_pkGeometry->m_shader_uniforms[i]->m_id, 1, m_pkGeometry->m_shader_uniforms[i]->m_value);
									glUniform1f(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0]);
			break;
		case ShaderObj::PT_FLOAT2: 			
									//std::cout << "PT_FLOAT:" << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0] << " , " << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[1] << std::endl;
									glUniform2f(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0], m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[1]);
			break;
		case ShaderObj::PT_FLOAT3: 	//std::cout << "PT_FLOAT 3:" << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0] << " , " << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[1] << " , " << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[2] << std::endl;
									//glUniform3fv(m_pkGeometry->m_shader_uniforms[i]->m_id, 1, m_pkGeometry->m_shader_uniforms[i]->m_value);
									glUniform3f(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0], m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[1], m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[2]);
			break;
		case ShaderObj::PT_FLOAT4: 	//std::cout << "PT_FLOAT 4:" << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0] << " , " << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[1] << " , " << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[2] << " , " << m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[3] <<  std::endl;
									//glUniform4fv(m_pkGeometry->m_shader_uniforms[i]->m_id, 1, m_pkGeometry->m_shader_uniforms[i]->m_value);
									glUniform4f(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0], m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[1], m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[2], m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[3]);
			break;
		case ShaderObj::PT_INT: glUniform1i(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0]));
			break;
		case ShaderObj::PT_INT2: glUniform2i(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0]), (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[1]));
			break;
		case ShaderObj::PT_INT3: glUniform3i(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0]), (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[1]), (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[2]));
			break;
		case ShaderObj::PT_INT4: glUniform4i(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[0]), (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[1]), (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[2]), (int)(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value[3]));
			break;
		case ShaderObj::PT_MAT2: glUniformMatrix2fv(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, 1, GL_FALSE, m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value);
			break;
		case ShaderObj::PT_MAT3: glUniformMatrix3fv(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, 1, GL_FALSE, m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value);
			break;
		case ShaderObj::PT_MAT4: glUniformMatrix4fv(m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_id, 1, GL_FALSE, m_pkGeometry->m_shader_uniforms[m_view->GetPass()][i]->m_value);
			break;
		default:
			break;
		}
	}
}

void RendererOpenGL::DrawGeometry()
{
	switch(m_pkGeometry->m_type)
	{
	case Geometry::GT_VertexGeometry: DrawVertexGeometry();
		break;
	}
}

void RendererOpenGL::DrawVertexGeometry()
{
	DrawGeometrySpecificUniforms();
	VertexGeometry* mesh = dynamic_cast<VertexGeometry*>(m_pkGeometry);

	std::map<int, int> dict = m_pkGeometry->GetDictShaderToVBO(m_view->GetPass());
	glBindVertexArray(mesh->m_vao_id);

	for(std::map<int, int>::iterator it = dict.begin(); it != dict.end(); it++)
	{
		switch(it->second)
		{
		case VertexGeometry::AT_POSITIONS:
				glEnableVertexAttribArray(it->first);    
				glBindBuffer(GL_ARRAY_BUFFER, mesh->m_vbovert);
				glVertexAttribPointer(it->first, 4, GL_FLOAT, GL_FALSE, 0, (void*)0 );
			break;
		case VertexGeometry::AT_NORMALS:
			if(mesh->m_normal_count > 0)
			{
				glEnableVertexAttribArray(it->first);    
				glBindBuffer(GL_ARRAY_BUFFER, mesh->m_vbonorm);
				glVertexAttribPointer(it->first, 3, GL_FLOAT, GL_FALSE, 0, (void*)0 );
			}
			break;
		case VertexGeometry::AT_TEXCOORD:
				glEnableVertexAttribArray(it->first);    
				glBindBuffer(GL_ARRAY_BUFFER, mesh->m_vbo_tex[0]);
				glVertexAttribPointer(it->first, 4, GL_FLOAT, GL_FALSE, 0, (void*)0 );
			break;
		case VertexGeometry::AT_TEXCOORD1:
				glEnableVertexAttribArray(it->first);    
				glBindBuffer(GL_ARRAY_BUFFER, mesh->m_vbo_tex[1]);
				glVertexAttribPointer(it->first, 4, GL_FLOAT, GL_FALSE, 0, (void*)0 );
			break;
		case VertexGeometry::AT_TEXCOORD2:
				glEnableVertexAttribArray(it->first);    
				glBindBuffer(GL_ARRAY_BUFFER, mesh->m_vbo_tex[2]);
				glVertexAttribPointer(it->first, 4, GL_FLOAT, GL_FALSE, 0, (void*)0 );
			break;
		case VertexGeometry::AT_COLORS:
			if(mesh->m_color_count > 0)
			{
				glEnableVertexAttribArray(it->first);    
				glBindBuffer(GL_ARRAY_BUFFER, mesh->m_vbocolor);
				glVertexAttribPointer(it->first, 4, GL_FLOAT, GL_FALSE, 0, (void*)0 );
			}
			break;
		case VertexGeometry::AT_ANIMATION:
			break;
		}
	}

	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, mesh->m_vboind);

	FBO::FBOPtr fbo = m_view->GetFBO();
	if(fbo != 0 && (fbo->m_dimension == 3))
	{
		for(int i = 0; i < fbo->GetDepth(); i++)
		{
			std::map<int, int> dict = m_pkGeometry->GetDictShaderUniform(m_view->GetPass());
			for(std::map<int, int>::iterator it = dict.begin(); it != dict.end(); it++)
			{
				switch(it->second)
				{
				case View::UT_ACT_FBO_DEPTH: glUniform1f( it->first, (float)(i)/(float)(fbo->GetDepth()));
					break;
				case View::UT_VIEWMATRIX:	glUniformMatrix4fv( it->first, 1, GL_FALSE, glm::value_ptr(m_view->GetCamera()->GetViewMatrix(i)));
					break;
				case View::UT_MODELVIEWPROJECTIONMATRIX:	glUniformMatrix4fv( it->first, 1, GL_FALSE, glm::value_ptr(m_view->GetCamera()->GetProjection()*m_view->GetCamera()->GetViewMatrix(i)*m_modelMatrix));
					break;
				}
			}

			
			fbo->BindTexture(i);
			
			switch(mesh->m_rendertype)
			{
			case Geometry::RT_TRIANGLE:
				glDrawElements(GL_TRIANGLES, mesh->m_index_count, GL_UNSIGNED_INT, (void*)0  );   //The starting point of the IBO
				break;
			case Geometry::RT_POINT:
				glDrawArrays(GL_POINTS, 0, mesh->m_index_count);
				break;
			}
		}
	}
	else	
	{
		switch(mesh->m_rendertype)
		{
		case Geometry::RT_TRIANGLE:
			glDrawElements(GL_TRIANGLES, mesh->m_index_count, GL_UNSIGNED_INT, 0);   //The starting point of the IBO
			break;
		case Geometry::RT_POINT:
			glDrawArrays(GL_POINTS, 0, std::min((unsigned int)(RenderStates::NumberOfParticles), mesh->m_index_count));
			break;
		}
	}

	for(std::map<int, int>::iterator it = dict.begin(); it != dict.end(); it++)
	{
		glDisableVertexAttribArray(it->first);    
	}

	glBindVertexArray(0);
}

void RendererOpenGL::EnableTexture(Texture::TexturePtr texture, int i)
{
	glActiveTexture(GL_TEXTURE0+i);	
	switch(texture->m_dimension)
	{
	case 1:
		if(texture->m_pingbong) 
		{
			if(texture->current_texture == 1)	glBindTexture(GL_TEXTURE_1D, texture->GetTexName());
			else								glBindTexture(GL_TEXTURE_1D, texture->GetTexName2());
		}
		else	glBindTexture(GL_TEXTURE_1D, texture->GetTexName());
		
		break;
	case 2:
		if(texture->m_pingbong) 
		{
			if(texture->current_texture == 1)	glBindTexture(GL_TEXTURE_2D, texture->GetTexName());
			else								glBindTexture(GL_TEXTURE_2D, texture->GetTexName2());
		}
		else	
		{
			glBindTexture(GL_TEXTURE_2D, texture->GetTexName());
		}
		break;
	case 3:
		if(texture->m_pingbong) 
		{
			if(texture->current_texture == 1)	
			{
				glBindTexture(GL_TEXTURE_3D, texture->GetTexName());
			}
			else								
			 {
				 glBindTexture(GL_TEXTURE_3D, texture->GetTexName2());
			}
		}
		else	glBindTexture(GL_TEXTURE_3D, texture->GetTexName());
		break;
	case 4:
		if(texture->m_pingbong) 
		{
			if(texture->current_texture == 1)	
			{
				glBindTexture(GL_TEXTURE_CUBE_MAP, texture->GetTexName());
			}
			else								
			 {
				 glBindTexture(GL_TEXTURE_CUBE_MAP, texture->GetTexName2());
			}
		}
		else	glBindTexture(GL_TEXTURE_CUBE_MAP, texture->GetTexName());
		break;
	}
}

void RendererOpenGL::DisableTexture(Texture::TexturePtr texture, int i)
{
	glActiveTexture(GL_TEXTURE0+i);	
	switch(texture->m_dimension)
	{
	case 1:
		glBindTexture(GL_TEXTURE_1D, 0);
		break;
	case 2:
		glBindTexture(GL_TEXTURE_2D, 0);
		break;
	case 3:
		glBindTexture(GL_TEXTURE_3D, 0);
		break;
	case 4:
		glBindTexture(GL_TEXTURE_CUBE_MAP, 0);
		break;
	}
}

void RendererOpenGL::LoadTexture(Texture::TexturePtr texture)
{
	if(texture->GetTexName() == 0)
	{
	Img* img = texture->GetImage();
	int i = 0;
		
	GLuint texname;
	glGenTextures(1, &texname);		
	glBindTexture(GL_TEXTURE_2D, texname);

	texture->m_width = img->GetWidth();
	texture->m_height = img->GetHeight();
	texture->m_depth = 0;

	switch(texture->TextureTyp)
	{
	case Texture::TT_NORMAL:
		/*switch(i)
		{
			case 0: glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,texture->FM_NEAREST);
					glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,texture->FM_NEAREST);
				break;
			case 1: glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,texture->FM_LINEAR);
					glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,texture->FM_LINEAR);
				break;
		}			
		*/

		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,GL_CLAMP_TO_EDGE );
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,GL_CLAMP_TO_EDGE );
		glTexImage2D(GL_TEXTURE_2D, 0,  GL_RGBA8, img->GetWidth(), img->GetHeight(), 0,  GL_RGBA,  GL_UNSIGNED_BYTE,  img->GetData());
		break;
	case Texture::TT_MIPMAP:
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, img->GetWidth(), img->GetHeight(), 0, GL_RGBA, GL_UNSIGNED_BYTE, img->GetData());
		std::cout << "---------------" << std::endl;
		glGenerateMipmap(GL_TEXTURE_2D); //PROBLEM
		std::cout << "---------------" << std::endl;
		std::cout << "HIER BIN ICH" << std::endl;
		std::cout << "---------------" << std::endl;
		break;
	case Texture::TT_ANISOTRPIC:
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S,GL_CLAMP_TO_EDGE );
		glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T,GL_CLAMP_TO_EDGE );
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAX_ANISOTROPY_EXT, 16.0f);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, img->GetWidth(), img->GetHeight(), 0, GL_BGRA, GL_UNSIGNED_BYTE, img->GetData());
		glGenerateMipmap(GL_TEXTURE_2D);
		
		break;
	}

	texture->SetTexName(texname);

	GetErrors();
	}
}