#include "SceneManager.h" 

SceneManager* SceneManager::sceneManager = 0;

SceneManager::SceneManager()
{
	camera = new Camera();
	camera->SetViewMatrix(glm::vec3(0.f,0.f,2.f), glm::vec3(0.f,0.f,0.f), glm::vec3(0.f,1.f, 0.f));
	camera->SetProjection(45.f, 1.f, 1.0f, 50.f);
	camera->SetViewport(800.f,800.f);

	volume = new Volume();
}

SceneManager::SceneManager(const SceneManager& sm)
{

}

SceneManager::~SceneManager()
{
	delete camera;
	if (volume) delete volume;
}

SceneManager& SceneManager::get()
{
	if (sceneManager == 0)
	{
		sceneManager = new SceneManager();
	}

	return (*sceneManager);
}

void SceneManager::loadVolume(const string& strFilename)
{
	if (volume)
	{
		delete volume;
	}

	volume = new Volume(strFilename);
}

Camera* SceneManager::getCamera()
{
	return camera;
}

Volume* SceneManager::getVolume()
{
	return volume;
}