#pragma once

#include <string>
#include "Camera.h"
#include "Volume.h"

using std::string;

class SceneManager
{

private:
	/** The constructor of the SceneManager */ 
	SceneManager();
	/** The copyconstructor of the SceneManager*/ 
	SceneManager(const SceneManager& sm);
	/** The destructor of the SceneManager */ 
	~SceneManager();
	/** Pointer to the SceneManager */ 
	static SceneManager* sceneManager;
	
	Camera* camera;

	Volume* volume;

public:

	static SceneManager& get();
	
	/** Loads the Volume from a file */
	void loadVolume(const string& strFilename);
	
	/** Returns a Pointer to the Camera */
	Camera* getCamera();
	/** Returns a Pointer to the Volume*/
	Volume* getVolume();

};