#include "VertexGeometry.h"
#include "utility.hpp"

VertexGeometry::VertexGeometry(void) : Geometry(GT_VertexGeometry)
{
}

VertexGeometry::VertexGeometry(int vertsize, int trigSize) : Geometry(GT_VertexGeometry)
{
	std::cout << "bevor init" << std::endl;

	m_normal_count = vertsize;
	m_color_count = 0;
	m_vertex_count = vertsize;
	m_index_count = trigSize;
	m_animation_count = 0;

	glGenVertexArrays(1, &m_vao_id);
	glBindVertexArray(m_vao_id);
	glBindVertexArray(0);
}

VertexGeometry::VertexGeometry(glm::vec4* positionsArray, glm::vec3* normalArray, glm::vec4* colors, glm::vec2* texCoord, glm::vec4* texCoord1, glm::vec4* texCoord2, int* indexArray, int vertsize, int trigSize) : Geometry(GT_VertexGeometry)
{
	//std::cout << "VertexGeometry(glm::vec4* positionsArray, glm::vec3* normalArray, glm::vec2* texCoord, glm::vec4* texCoord1, glm::vec4* texCoord2, int* indexArray, int vertsize, int trigSize) : Geometry(GT_VertexGeometry)" << std::endl;
	m_TextureCoords.insert(std::pair<unsigned int, glm::vec4*>(0, new glm::vec4[vertsize]));
	if(texCoord1 != 0) m_TextureCoords.insert(std::pair<unsigned int, glm::vec4*>(1, new glm::vec4[vertsize]));
	if(texCoord2 != 0) m_TextureCoords.insert(std::pair<unsigned int, glm::vec4*>(2, new glm::vec4[vertsize]));

	std::cout << "VertSize: " << vertsize << std::endl;
	std::cout << "TrigSize: " << trigSize << std::endl;

	m_PositionArray = new glm::vec4[vertsize];		for(int i = 0; i < vertsize; i++)	m_PositionArray[i] = positionsArray[i];
	//std::cout << "Position array" << std::endl;
	m_NormalArray = new glm::vec3[vertsize];		for(int i = 0; i < vertsize; i++)	m_NormalArray[i] = normalArray[i];
	//std::cout << "Normal array" << std::endl;
	m_TextureCoords[0] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++)	m_TextureCoords[0][i] = glm::vec4(texCoord[i].x, texCoord[i].y, 0.f, 0.f);
	//std::cout << "Texture array" << std::endl;
	if(texCoord1 != 0){ m_TextureCoords[1] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++)	m_TextureCoords[1][i] = texCoord1[i];}
	//std::cout << "Texture array 1" << std::endl;
	if(texCoord2 != 0){ m_TextureCoords[2] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++)	m_TextureCoords[2][i] = texCoord2[i];}
	//std::cout << "Texture array 2" << std::endl;
	m_IndexArray = new unsigned int[trigSize];		for(int i = 0; i < trigSize; i++)	m_IndexArray[i] = indexArray[i];
	m_ColorArray = new glm::vec4[vertsize];			for(int i = 0; i < vertsize; i++)	m_ColorArray[i] = colors[i];

	std::cout << "bevor init" << std::endl;

	m_normal_count = vertsize;
	m_color_count = vertsize;
	m_vertex_count = vertsize;
	m_index_count = trigSize;
	m_animation_count = 0;

	BuildVBO();
}

VertexGeometry::VertexGeometry(glm::vec4* positionsArray, glm::vec3* normalArray, glm::vec2* texCoord, glm::vec4* texCoord1, glm::vec4* texCoord2, int* indexArray, int vertsize, int trigSize) : Geometry(GT_VertexGeometry)
{
	//std::cout << "VertexGeometry(glm::vec4* positionsArray, glm::vec3* normalArray, glm::vec2* texCoord, glm::vec4* texCoord1, glm::vec4* texCoord2, int* indexArray, int vertsize, int trigSize) : Geometry(GT_VertexGeometry)" << std::endl;
	m_TextureCoords.insert(std::pair<unsigned int, glm::vec4*>(0, new glm::vec4[vertsize]));
	if(texCoord1 != 0) m_TextureCoords.insert(std::pair<unsigned int, glm::vec4*>(1, new glm::vec4[vertsize]));
	if(texCoord2 != 0) m_TextureCoords.insert(std::pair<unsigned int, glm::vec4*>(2, new glm::vec4[vertsize]));

	std::cout << "VertSize: " << vertsize << std::endl;
	std::cout << "TrigSize: " << trigSize << std::endl;

	m_PositionArray = new glm::vec4[vertsize];		for(int i = 0; i < vertsize; i++)	m_PositionArray[i] = positionsArray[i];
	m_NormalArray = new glm::vec3[vertsize];		for(int i = 0; i < vertsize; i++)	m_NormalArray[i] = normalArray[i];
	m_TextureCoords[0] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++)	m_TextureCoords[0][i] = glm::vec4(texCoord[i].x, texCoord[i].y, 0.f, 0.f);
	if(texCoord1 != 0){ m_TextureCoords[1] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++){	m_TextureCoords[1][i] = texCoord1[i];}}
	if(texCoord2 != 0){ m_TextureCoords[2] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++){	m_TextureCoords[2][i] = texCoord2[i];}}
	m_IndexArray = new unsigned int[trigSize];		for(int i = 0; i < trigSize; i++)	m_IndexArray[i] = indexArray[i];

	m_normal_count = vertsize;
	m_color_count = 0;
	m_vertex_count = vertsize;
	m_index_count = trigSize;
	m_animation_count = 0;

	BuildVBO();
}

VertexGeometry::VertexGeometry(glm::vec4* positionsArray, glm::vec3* normalArray, glm::vec2* texCoord, glm::vec4* colors, int* indexArray, int vertsize, int trigSize) : Geometry(GT_VertexGeometry)
{
	m_TextureCoords.insert(std::pair<unsigned int, glm::vec4*>(0, new glm::vec4[vertsize]));

	std::cout << "VertSize: " << vertsize << std::endl;
	std::cout << "TrigSize: " << trigSize << std::endl;

	m_PositionArray = new glm::vec4[vertsize];		for(int i = 0; i < vertsize; i++)	m_PositionArray[i] = positionsArray[i];
	m_NormalArray = new glm::vec3[vertsize];		for(int i = 0; i < vertsize; i++)	m_NormalArray[i] = normalArray[i];
	m_TextureCoords[0] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++)	m_TextureCoords[0][i] = glm::vec4(texCoord[i].x, texCoord[i].y, 0.f, 0.f);
	m_ColorArray = new glm::vec4[vertsize];			for(int i = 0; i < vertsize; i++)	m_ColorArray[i] = colors[i];
	m_IndexArray = new unsigned int[trigSize];		for(int i = 0; i < trigSize; i++)	m_IndexArray[i] = indexArray[i];

	m_normal_count = vertsize;
	m_color_count = vertsize;
	m_vertex_count = vertsize;
	m_index_count = trigSize;
	m_animation_count = 0;

	BuildVBO();
}

VertexGeometry::VertexGeometry(glm::vec4* positionsArray, glm::vec3* normalArray, glm::vec2* texCoord, glm::vec4** animation, int* indexArray, int vertsize, int trigSize, int animationsize) : Geometry(GT_VertexGeometry)
{
	m_TextureCoords.insert(std::pair<unsigned int, glm::vec4*>(0, new glm::vec4[vertsize]));

	std::cout << "Animation " << std::endl;
	std::cout << "VertSize: " << vertsize << std::endl;
	std::cout << "TrigSize: " << trigSize << std::endl;

	m_PositionArray = new glm::vec4[vertsize];		for(int i = 0; i < vertsize; i++)	m_PositionArray[i] = positionsArray[i];
	m_NormalArray = new glm::vec3[vertsize];		for(int i = 0; i < vertsize; i++)	m_NormalArray[i] = normalArray[i];
	m_TextureCoords[0] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++)	m_TextureCoords[0][i] = glm::vec4(texCoord[i].x, texCoord[i].y, 0.f, 0.f);
	
	for(int j = 0; j < animationsize; j++)
	{
		m_AnimationVertex[0] = new glm::vec4[vertsize];	
		for(int i = 0; i < vertsize; i++)	m_AnimationVertex[j][i] = animation[j][i];
	}
	
	m_IndexArray = new unsigned int[trigSize];		for(int i = 0; i < trigSize; i++)	m_IndexArray[i] = indexArray[i];

	m_normal_count = vertsize;
	m_color_count = 0;
	m_vertex_count = vertsize;
	m_index_count = trigSize;
	m_animation_count = animationsize;

	BuildVBO();
}

VertexGeometry::VertexGeometry(glm::vec4* positionsArray, glm::vec3* normalArray, glm::vec2* texCoord, glm::vec4* bones_weights, glm::vec4* bones_indices, glm::mat4* bones_matrizen, int* indexArray, int vertsize, int trigsize, int bonesize): Geometry(GT_VertexGeometry)
{
	m_PositionArray = new glm::vec4[vertsize];		for(int i = 0; i < vertsize; i++)	m_PositionArray[i] = positionsArray[i];
	m_NormalArray = new glm::vec3[vertsize];		for(int i = 0; i < vertsize; i++)	m_NormalArray[i] = normalArray[i];
	m_TextureCoords[0] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++)	m_TextureCoords[0][i] = glm::vec4(texCoord[i].x, texCoord[i].y, 0.f, 0.f);
	m_TextureCoords[1] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++)	m_TextureCoords[1][i] = bones_indices[i];
	m_TextureCoords[2] = new glm::vec4[vertsize];	for(int i = 0; i < vertsize; i++)	m_TextureCoords[2][i] = bones_weights[i];
	m_IndexArray = new unsigned int[trigsize];		for(int i = 0; i < trigsize; i++)	m_IndexArray[i] = indexArray[i];
	
	bones = new glm::mat4[bonesize];//				for(int i = 0; i < bonesize; i++)	bones[i] = bones_matrizen[i];
	oldBones = new glm::mat4[bonesize];				for(int i = 0; i < bonesize; i++)	oldBones[i] = glm::mat4();
	bones_helper= new glm::mat4[bonesize];			for(int i = 0; i < bonesize; i++)	bones_helper[i] = glm::mat4();
	act_bones = new glm::mat4[bonesize];			for(int i = 0; i < bonesize; i++)	act_bones[i] = glm::mat4();

	m_color_count = 0;
	m_animation_count = 0;
	m_bones_count = bonesize;;
	m_normal_count = vertsize;
	m_vertex_count = vertsize;
	m_index_count = trigsize;

	BuildVBO();
}


VertexGeometry::~VertexGeometry(void)
{
	glDeleteBuffers(1, &m_vbovert);
	if(m_normal_count > 0) glDeleteBuffers(1, &m_vbonorm);
	if(m_color_count > 0) glDeleteBuffers(1, &m_vbocolor);

	for(int i = m_vbo_tex.size()-1; i >= 0; i--) glDeleteBuffers(1, &m_vbo_tex[i]);
	glDeleteBuffers(1, &m_vboind);
}

void VertexGeometry::BuildVBO()
{
	std::cout << "BuildVBO" << std::endl;

	glm::vec4 tmp_min(999999.f,999999.f,999999.f,1.f), tmp_max(-999999.f,-999999.f,-999999.f,1.f);
	for(unsigned int i = 0; i < m_vertex_count; i++)
	{
		if(tmp_min.x > m_PositionArray[i].x) tmp_min.x = m_PositionArray[i].x;
		if(tmp_min.y > m_PositionArray[i].y) tmp_min.y = m_PositionArray[i].y;
		if(tmp_min.z > m_PositionArray[i].z) tmp_min.z = m_PositionArray[i].z;
		if(tmp_max.x < m_PositionArray[i].x) tmp_max.x = m_PositionArray[i].x;
		if(tmp_max.y < m_PositionArray[i].y) tmp_max.y = m_PositionArray[i].y;
		if(tmp_max.z < m_PositionArray[i].z) tmp_max.z = m_PositionArray[i].z;
	}

	unsigned int n = 0;

	glGenVertexArrays(1, &m_vao_id);
	glBindVertexArray(m_vao_id);

	//Building Vertices VBOs
	glGenBuffers(1, &m_vbovert);
	glBindBuffer(GL_ARRAY_BUFFER, m_vbovert);
	glBufferData(GL_ARRAY_BUFFER, m_vertex_count * sizeof(glm::vec4), m_PositionArray, GL_DYNAMIC_DRAW);
    glVertexAttribPointer(n, 4, GL_FLOAT, GL_FALSE, 0, (void*)0 );
	glEnableVertexAttribArray(n);
	get_errors();
	n++;
 
	if(m_normal_count > 0)
	{
		//Building Normal VBOs
		glGenBuffers(1, &m_vbonorm);
	    glBindBuffer(GL_ARRAY_BUFFER, m_vbonorm);
		glBufferData(GL_ARRAY_BUFFER, m_vertex_count * sizeof(glm::vec3), m_NormalArray, GL_DYNAMIC_DRAW);
	    glVertexAttribPointer(n, 3, GL_FLOAT, GL_FALSE, 0, (void*)0 );
		glEnableVertexAttribArray(n);
		n++;
	}
	std::cout << "m_normal_count coords created " << std::endl;

	if(m_color_count > 0)
	{
		//Building Color VBOs
		glGenBuffers(1, &m_vbocolor);
		glBindBuffer(GL_ARRAY_BUFFER, m_vbocolor);
		glBufferData(GL_ARRAY_BUFFER, m_vertex_count * sizeof(glm::vec4), m_ColorArray, GL_DYNAMIC_DRAW);
		glVertexAttribPointer(n, 4, GL_FLOAT, GL_FALSE, 0, (void*)0 );
		glEnableVertexAttribArray(n);
		n++;
	}
	std::cout << "m_color_count coords created " << std::endl;

	//Building Texture VBOs
	for(unsigned int i = 0; i < m_TextureCoords.size(); i++)
	{
		m_vbo_tex[i] = 0;
		if(m_TextureCoords[i] != 0)
		{
			glGenBuffers(1, &m_vbo_tex[i]);
			glBindBuffer(GL_ARRAY_BUFFER, m_vbo_tex[i]);
			glBufferData(GL_ARRAY_BUFFER, m_vertex_count * sizeof(glm::vec4), &m_TextureCoords[i][0], GL_DYNAMIC_DRAW);
			glVertexAttribPointer(n, 4, GL_FLOAT, GL_FALSE, 0, (void*)0 );
			glEnableVertexAttribArray(n);
			n++;
		}
	}
	std::cout << "texture coords created " << std::endl;

	
	//Building Animation VBOs
	for(unsigned int i = 0; i < m_animation_count; i++)
	{
		glGenBuffers(1, &m_vbo_animation[i]);
		glBindBuffer(GL_ARRAY_BUFFER, m_vbo_animation[i]);
		glBufferData(GL_ARRAY_BUFFER, m_vertex_count * sizeof(glm::vec4), &m_TextureCoords[0][0], GL_DYNAMIC_DRAW);
		glEnableVertexAttribArray(n);
		glVertexAttribPointer(n, 4, GL_FLOAT, GL_FALSE, 0, (void*)0 );
		n++;
	}
	std::cout << "animation created " << std::endl;

	//Building Triangles
	glGenBuffers(1, &m_vboind);
	glBindBuffer(GL_ELEMENT_ARRAY_BUFFER, m_vboind);
	glBufferData(GL_ELEMENT_ARRAY_BUFFER, sizeof(GL_UNSIGNED_INT)*m_index_count, m_IndexArray, GL_DYNAMIC_DRAW);
	//std::cout << "indices created " << std::endl;

	for(unsigned int i = 0; i < n; i++) glDisableVertexAttribArray(n);
	/*if(m_normal_count > 0) glDisableVertexAttribArray(1);
	glDisableVertexAttribArray(2);
	glDisableVertexAttribArray(3);
	if(m_color_count > 0) glDisableVertexAttribArray(4);
	*/
	get_errors();

/*	delete [] m_PositionArray;
	if(m_normal_count > 0) delete [] m_NormalArray;
	delete [] m_IndexArray;
	if(m_color_count > 0) delete [] m_ColorArray;
	for(int i = 0; i < m_TextureCoords.size(); i++)	delete [] m_TextureCoords[i];
	m_TextureCoords.clear();
*/
	glBindVertexArray(0);

	std::cout << "VBO builded" << std::endl;
}

const bool VertexGeometry::operator<(VertexGeometry i) const
{ 
	return distToCam<i.distToCam;
}

const bool VertexGeometry::operator<(VertexGeometry* i) const
{ 
	return distToCam<i->distToCam;
}

void VertexGeometry::Update(float* positionsArray)
{
	glBindBuffer(GL_ARRAY_BUFFER, m_vbovert);
	float* ptr = (float*)glMapBuffer(GL_ARRAY_BUFFER, GL_WRITE_ONLY);

	// if the pointer is valid(mapped), update VBO
	if(ptr)
	{
		for(unsigned int i = 0; i < m_vertex_count; i++)
		{
			ptr[(i*4)] = positionsArray[(i*3)];
			ptr[(i*4)+1] = positionsArray[(i*3)+1];
			ptr[(i*4)+2] = positionsArray[(i*3)+2];
			//ptr[(i*4)+3] = 1.f;
		}

		glUnmapBuffer(GL_ARRAY_BUFFER); // unmap it after use
	}

}