#include "View.h"
#include "VertexGeometry.h"

View::View(void) : m_root(), m_pass(0), m_grid(128,128,128)
{
}


View::~View(void)
{
}

void View::SetPass(unsigned int pass)
{
	m_pass = pass;
}

unsigned int View::GetPass()
{
	return m_pass;
}

void View::SetLight(Light* light)
{
	m_light = light;
}

Light* View::GetLight()
{
	return m_light;
}

void View::AddFBO(FBO::FBOPtr fbo)
{
	m_fbo.push_back(fbo);
}

void View::SetFBO(unsigned int id, FBO::FBOPtr fbo)
{
	m_fbo[id]= fbo;
}

FBO::FBOPtr View::GetFBO()
{
	if(m_fbo.size() > 0)	return m_fbo[0];
	else					return FBO::FBOPtr();
}

FBO::FBOPtr View::GetFBO(int at)
{
	return m_fbo[at];
}

void View::SetCamera(Camera* camera)
{
	m_camera = camera;
}

void View::SetRoot(INode* inode)
{
	m_root = inode;
}

Camera* View::GetCamera()
{
	return m_camera;
}

INode* View::GetRoot()
{
	return m_root;
}

glm::vec3 View::GetGrid()
{
	return m_grid;
}

void View::SetGrid(glm::vec3 grid)
{
	m_grid = grid;
}