#pragma once
#include <windows.h>
#include <GL/glew.h>

/* itoa example */
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>
#include <io.h>
#include <sstream>

using std::string;
using std::cerr;
using std::cout;
using std::endl;

#include "utility.hpp"

#define PI 3.1415926535897f

// converts from string to Type
template <class Type>
inline const Type fromString(const std::string & strString)
{
	Type tValue;
	std::stringstream(std::string(strString)) >> tValue;		
	return tValue;
};

// converts from string to Type, returns true if successful
template <class Type>
inline const bool fromString(Type & tValue, const std::string & strString)
{
	Type tTemp;

	std::stringstream ss;
	ss << strString;
	ss >> std::ws;

	if (ss >> tTemp)
	{
		ss >> std::ws;

		if (ss.eof())
		{
			tValue = tTemp;
			return true;
		}
	}

	return false;
};

// converts from Type to string
template <class Type>
inline const std::string toString(const Type & tValue)
{
	std::stringstream ss;
	ss << tValue;
	return ss.str();
};