#pragma once
#include "vector_types.h"
#include <cutil_inline.h>
#include <cutil_math.h>
#include <math.h>
#include "math_constants.h"

#include <thrust/device_vector.h>
#include "thrust/device_ptr.h"
#include "thrust/for_each.h"
#include "thrust/iterator/zip_iterator.h"
#include "thrust/sort.h"
#include "thrust/copy.h"
#include "curand_kernel.h"

struct Particle {
    float globalDamping;
	float3 predefinedDirection;
	
	float k_c;
	float k_f;
	float k_p;
	float k_d;

	float mass;
	float rho0;
	float viscosity;
	float siftness;
	float gravity;

	float SpringCoefficient;
	float DampingCoefficient;
	float ShearCoefficient;

	float SpringCoefficientCT;
	float DampingCoefficientCT;
	float ShearCoefficientCT;

	float elapsed_time;
	float3 sortVector;
};